<?php
/**     
 * Smdesign Studio
 *
 * Kupindo Products Feed
 * @category       Smdesign Studio
 * @copyright      Copyright (c) 2018 Kupindo (http://www.smdesign.rs/)
 * @author         Smdesign Studio
 * @license        http://www.smdesign.rs/kupindo-integracija
 * @terms of use   http://www.smdesign.rs/kupindo-integracija
 * @version        Release: 1.0
 * @since          Class available since Release 1.0
 */ 
 
class Kupindo_Feed_Block_Adminhtml_Items_Edit_Tabs extends Mage_Adminhtml_Block_Widget_Tabs
{
    public function __construct()
    {

        parent::__construct();
        $this->setId('kupindo_feed_tabs');
        $this->setDestElementId('edit_form');
        $this->setTitle($this->__('Feed Information'));

    }

    protected function _prepareLayout()
    {

        if (($type = $this->getRequest()->getParam('type', null)) || (Mage::registry('kupindo_feed') && ($type = Mage::registry('kupindo_feed')->getType()))) {

            $this->addTab('main_section', array(
                    'label'   => $this->__('Item information'),
                    'title'   => $this->__('Item information'),
                    'content' => $this->getLayout()->createBlock('kupindo_feed/adminhtml_items_edit_tab_main')->toHtml(),
                )
            );

            if ($type == 'csv') {
                $this->addTab('content_section', array(
                        'label'   => $this->__('Content Settings'),
                        'title'   => $this->__('Content Settings'),
                        'content' => $this->getLayout()->createBlock('kupindo_feed/adminhtml_items_edit_tab_content_csv')
                                ->setTemplate('kupindo/feed/item/edit/content.phtml')->toHtml(),
                    )
                );

            } else {
                $this->addTab('content_section', array(
                        'label'   => $this->__('Content Settings'),
                        'title'   => $this->__('Content Settings'),
                        'content' => $this->getLayout()->createBlock('kupindo_feed/adminhtml_items_edit_tab_content_xml')->toHtml(),
                    )
                );
            }


            $this->addTab('filter_section', array(
                    'label'   => $this->__('Filter Configuration'),
                    'title'   => $this->__('Filter Configuration'),
                    'content' => $this->getLayout()->createBlock('kupindo_feed/adminhtml_items_edit_tab_filter')
                            ->setTemplate('kupindo/feed/item/edit/filter.phtml')->toHtml(),
                )
            );

            $this->addTab('ftp_section', array(
                    'label'   => $this->__('FTP Settings'),
                    'title'   => $this->__('FTP Settings'),
                    'content' => $this->getLayout()->createBlock('kupindo_feed/adminhtml_items_edit_tab_ftp')->toHtml(),
                )
            );

            $this->addTab('advanced', array(
                    'label'   => $this->__('Advanced Settings'),
                    'title'   => $this->__('Advanced Settings'),
                    'content' => $this->getLayout()->createBlock('kupindo_feed/adminhtml_items_edit_tab_advanced')->toHtml(),
                )
            );

        } else {

            $this->addTab('main_section', array(
                    'label'   => $this->__('Content Settings'),
                    'title'   => $this->__('Content Settings'),
                    'content' => $this->getLayout()->createBlock('kupindo_feed/adminhtml_items_edit_tab_type')->toHtml(),
                )
            );

        }
        if ($tabId = addslashes(htmlspecialchars($this->getRequest()->getParam('tab')))) {

            $this->setActiveTab($tabId);
        }

        return parent::_beforeToHtml();

    }

}